// TvRock DTV Target.
#include <windows.h>
#include <shlwapi.h>
#include <tchar.h>
#include <vector>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT	// vOCNXƂĎ
#include "TVTestPlugin.h"
#include "TvRockDTV.h"

#pragma comment(lib,"shlwapi.lib")

using namespace TvRock;

#define ArrayLength(a) (sizeof(a) / sizeof(a[0]))

// t@C̊gq
#define FILE_EXTENSION	L".ts"

// nfW̕`l͈̔
#define TERRESTRIAL_CHANNEL_FIRST	13
#define TERRESTRIAL_CHANNEL_LAST	63

// nfWTSID?
inline bool IsTerrestrialTSID(WORD TSID) {
	return (TSID & 0xFF00) == 0x7F00 || (TSID & 0xFF00) == 0x7E00;
}
// BSNetworkID?
inline bool IsBsNetworkID(WORD NetworkID) {
	return NetworkID == 4;
}
// BSTSID?
inline bool IsBsTSID(WORD TSID) {
	return (TSID & 0xF000) == 0x4000;
}
// CSNetworkID?
inline bool IsCsNetworkID(WORD NetworkID) {
	return NetworkID >= 6 && NetworkID <= 10;
}
// CSTSID?
inline bool IsCsTSID(WORD TSID) {
	return !IsBsTSID(TSID) && !IsTerrestrialTSID(TSID);
}

struct FreqInfo {
	WORD Frequency;
	WORD TSID;
};

static const FreqInfo DefaultBSChannelList[] = {
	{11727,	0x4010},	// BS1/TS0 BS
	{11727,	0x4011},	// BS1/TS1 BS-TBS
	{11766,	0x4030},	// BS3/TS0 WOWOW
	{11766,	0x4031},	// BS3/TS1 BSWp
	{11880,	0x4090},	// BS9/TS0 BS11
	{11880,	0x4091},	// BS9/TS1 Star Channel HV
	{11880,	0x4092},	// BS9/TS2 TwellV
	{11958,	0x40D0},	// BS13/TS0 BSe
	{11958,	0x40D1},	// BS13/TS1 BStW
	{11996,	0x40F1},	// BS15/TS1 NHK BS1/2
	{11996,	0x40F2},	// BS15/TS2 NHK BS-hi
	{12034,	0x4310},	// BS17/TS1 nfW΍
	{12034,	0x4311},	// BS17/TS2 nfW΍
};

static const FreqInfo DefaultCSChannelList[] = {
	{12291,	0x6020},	// ND2 110CS #1
	{12331,	0x7040},	// ND4 110CS #2
	{12371,	0x7060},	// ND6 110CS #3
	{12411,	0x6080},	// ND8 110CS #4
	{12451,	0x60A0},	// ND10 110CS #5
	{12491,	0x70C0},	// ND12 110CS #6
	{12531,	0x70E0},	// ND14 110CS #7
	{12571,	0x7100},	// ND16 110CS #8
	{12611,	0x7120},	// ND18 110CS #9
	{12651,	0x7140},	// ND20 110CS #10
	{12691,	0x7160},	// ND22 110CS #11
	{12731,	0x7180},	// ND24 110CS #12
};

#ifdef WIN64
namespace TvRock {
static inline HINSTANCE LoadDTVModule64() {
	WCHAR path[MAX_PATH];
	memset(path,0,sizeof(path));
	if (__read_software_registry(TEXT("SOFTWARE\\") TRDTV_TVROCK_NAME,TEXT("DOCUMENT"),path,MAX_PATH*sizeof(WCHAR)))
		return NULL;
	wcscat_s(path,MAX_PATH,L"\\TvRockDTV.x64.dll");
	return LoadLibrary(path);
}
}
#endif


// `l
class CChannelSearch
{
	typedef std::vector<FreqInfo> ChannelList;

	struct FreqRange {
		WORD Min, Max;
		FreqRange() : Min(0), Max(0) {}
	};

	TVTest::CTVTestApp *m_pApp;
	bool m_fInitialized;
	bool m_fSetChannelServiceSupported;
	int m_TerrestrialIndex;
	int m_TerrestrialIndex2;
	int m_BSIndex;
	int m_CSIndex;
	bool m_fTerraIndexSpecified;
	bool m_fTerraIndex2Specified;
	bool m_fBSIndexSpecified;
	bool m_fCSIndexSpecified;
	ChannelList m_BSChannelList;
	ChannelList m_CSChannelList;
	FreqRange m_BSFrequencyRange;
	FreqRange m_CSFrequencyRange;

	// `[jOԂ̃CfbNX̎擾
	void GetSpaceIndex() {
		if (m_fInitialized)
			return;

		bool fFound;
		WCHAR szLog[256];
		TVTest::ChannelInfo ChannelInfo;

		int NumSpaces = 0;
		m_pApp->GetTuningSpace(&NumSpaces);

		// nfW̃`[jOԂ̎擾
		if (m_TerrestrialIndex >= 0) {
			fFound = true;
			if (!m_fTerraIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_TerrestrialIndex, 0, &ChannelInfo)
						|| !IsTerrestrialTSID(ChannelInfo.TransportStreamID))) {
				fFound = false;
				for (int i = 0; i < NumSpaces; i++) {
					if (m_pApp->GetChannelInfo(i, 0, &ChannelInfo)
							&& IsTerrestrialTSID(ChannelInfo.TransportStreamID)) {
						m_TerrestrialIndex = i;
						fFound = true;
						break;
					}
				}
			}
			::wsprintfW(szLog,
						fFound ? L"nfW̃`[jOԂ擾܂B(%d)":
						         L"nfW̃`[jOԂ擾łȂ߁A%d ɉ肵܂B",
						m_TerrestrialIndex);
			m_pApp->AddLog(szLog);
			if (fFound && !m_fTerraIndex2Specified
					&& m_pApp->GetChannelInfo(m_TerrestrialIndex + 1, 0, &ChannelInfo)
					&& IsTerrestrialTSID(ChannelInfo.TransportStreamID)) {
				m_TerrestrialIndex2 = m_TerrestrialIndex + 1;
			}
			if (m_TerrestrialIndex2 >= 0) {
				::wsprintfW(szLog, L"nfW2̃`[jOԂ擾܂B(%d)",
							m_TerrestrialIndex2);
				m_pApp->AddLog(szLog);
			}
		}

		// BS̃`[jOԂ̎擾
		if (m_BSIndex >= 0) {
			fFound = true;
			if (!m_fBSIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_BSIndex, 0, &ChannelInfo)
						|| (ChannelInfo.NetworkID != 0
							&& !IsBsNetworkID(ChannelInfo.NetworkID))
						|| !IsBsTSID(ChannelInfo.TransportStreamID))) {
				// ܂ŏ̃`l̂ݒׂ
				fFound = false;
				for (int i = 0; i < NumSpaces; i++) {
					if (m_pApp->GetChannelInfo(i, 0, &ChannelInfo)
							&& (IsBsNetworkID(ChannelInfo.NetworkID)
								|| IsBsTSID(ChannelInfo.TransportStreamID))) {
						m_BSIndex = i;
						fFound = true;
						break;
					}
				}
				// tȂꍇASẴ`l𒲂ׂ
				if (!fFound) {
					for (int Space = 0; !fFound && Space < NumSpaces; Space++) {
						for (int i = 1; m_pApp->GetChannelInfo(Space, i, &ChannelInfo); i++) {
							if (IsBsNetworkID(ChannelInfo.NetworkID)
									|| IsBsTSID(ChannelInfo.TransportStreamID)) {
								m_BSIndex = Space;
								fFound = true;
								break;
							}
						}
					}
				}
			}
			::wsprintfW(szLog,
						fFound ? L"BS̃`[jOԂ擾܂B(%d)":
						         L"BS̃`[jOԂ擾łȂ߁A%d ɉ肵܂B",
						m_BSIndex);
			m_pApp->AddLog(szLog);
		}

		// CS̃`[jOԂ̎擾
		if (m_CSIndex >= 0) {
			fFound = true;
			if (!m_fCSIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_CSIndex, 0 ,&ChannelInfo)
						|| (ChannelInfo.NetworkID != 0
							&& !IsCsNetworkID(ChannelInfo.NetworkID))
						|| !IsCsTSID(ChannelInfo.TransportStreamID))) {
				// ܂ŏ̃`l̂ݒׂ
				fFound = false;
				for (int i = 0; i < NumSpaces; i++) {
					if (m_pApp->GetChannelInfo(i, 0, &ChannelInfo)
							&& (IsCsNetworkID(ChannelInfo.NetworkID)
								|| IsCsTSID(ChannelInfo.TransportStreamID))) {
						m_CSIndex = i;
						fFound = true;
						break;
					}
				}
				// tȂꍇASẴ`l𒲂ׂ
				if (!fFound) {
					for (int Space = 0; !fFound && Space < NumSpaces; Space++) {
						for (int i = 1; m_pApp->GetChannelInfo(Space, i, &ChannelInfo); i++) {
							if (IsCsNetworkID(ChannelInfo.NetworkID)
									|| IsCsTSID(ChannelInfo.TransportStreamID)) {
								m_CSIndex = Space;
								fFound = true;
								break;
							}
						}
					}
				}
			}
			::wsprintfW(szLog,
						fFound ? L"CS̃`[jOԂ擾܂B(%d)":
						         L"CS̃`[jOԂ擾łȂ߁A%d ɉ肵܂B",
						m_CSIndex);
			m_pApp->AddLog(szLog);
		}

		m_fInitialized = true;
	}

	// gݒ̓ǂݍ
	bool LoadFrequencySettings(LPCTSTR pszIniFileName, LPCTSTR pszSectionName, ChannelList *pChannelList) {
		TCHAR Buffer[4096];

		if (::GetPrivateProfileSection(pszSectionName, Buffer, ArrayLength(Buffer), pszIniFileName) <= 0)
			return false;
		pChannelList->clear();
		for (LPTSTR p = Buffer; *p != _T('\0'); p += ::lstrlen(p) + 1) {
			FreqInfo Info;

			Info.TSID = (WORD)_tcstoul(p, &p, 0);
			if (*p == _T('=')) {
				Info.Frequency = (WORD)_tcstoul(p + 1, NULL, 0);
				if (Info.TSID != 0 && Info.Frequency != 0) {
					pChannelList->push_back(Info);
#ifdef _DEBUG
					TCHAR szTrace[256];
					::wsprintf(szTrace, TEXT("%s : %04x = %d MHz"), pszSectionName, Info.TSID, Info.Frequency);
					::OutputDebugString(szTrace);
#endif
				}
			}
		}
		return !pChannelList->empty();
	}

	// g͈̔͂擾
	void GetFrequencyRange(const ChannelList &ChannelList, FreqRange *pRange) {
		WORD Min = 0xFFFF, Max = 0;

		for (size_t i = 0; i < ChannelList.size(); i++) {
			const WORD Frequency = ChannelList[i].Frequency;
			if (Frequency < Min)
				Min = Frequency;
			if (Frequency > Max)
				Max = Frequency;
		}
		pRange->Min = Min;
		pRange->Max = Max;
	}

	// TVTest̃`lύX
	bool SetChannel(int Space, int Channel, WORD ServiceID) {
		if (m_fSetChannelServiceSupported) {
			return m_pApp->SetChannel(Space, Channel, ServiceID);
		} else {
			return m_pApp->SetChannel(Space, Channel)
				&& m_pApp->SetService(ServiceID, true);
		}
	}

	// T[rXID̈v`lT
	int FindChannelByServiceID(int Space, WORD ServiceID) {
		TVTest::ChannelInfo ChannelInfo;

		for (int i = 0; m_pApp->GetChannelInfo(Space, i, &ChannelInfo); i++) {
			if (ChannelInfo.ServiceID == ServiceID)
				return i;
		}
		return -1;
	}

	// TSIDServiceID̈v`lT
	int FindChannelByTSIDAndServiceID(int Space, WORD TSID, WORD ServiceID) {
		TVTest::ChannelInfo ChannelInfo;

		for (int i = 0; m_pApp->GetChannelInfo(Space, i, &ChannelInfo); i++) {
			if (ChannelInfo.TransportStreamID == TSID
					&& (ServiceID == 0 || ChannelInfo.ServiceID == ServiceID))
				return i;
		}
		return -1;
	}

public:
	CChannelSearch(TVTest::CTVTestApp *pApp)
		: m_pApp(pApp)
		, m_fInitialized(false)
		, m_fSetChannelServiceSupported(false)
		, m_TerrestrialIndex(-1)
		, m_TerrestrialIndex2(-1)
		, m_BSIndex(-1)
		, m_CSIndex(-1)
		, m_fTerraIndexSpecified(false)
		, m_fTerraIndex2Specified(false)
		, m_fBSIndexSpecified(false)
		, m_fCSIndexSpecified(false)
	{
	}

	void Init(LPCTSTR pszIniFileName, LPCTSTR pszSectionName) {
		// vOCo[W 0.0.8 ȍ~ł̓`lƃT[rXID𓯎Ɏwł
		TVTest::HostInfo HostInfo;
		if (m_pApp->GetHostInfo(&HostInfo))
			m_fSetChannelServiceSupported = HostInfo.SupportedPluginVersion >= TVTEST_PLUGIN_VERSION_(0,0,8);

		// ݒǂݍ
		m_TerrestrialIndex = ::GetPrivateProfileInt(pszSectionName, TEXT("TerrestrialIndex"), -1, pszIniFileName);
		m_fTerraIndexSpecified = m_TerrestrialIndex >= 0;
		if (m_fTerraIndexSpecified) {
			m_TerrestrialIndex2 = ::GetPrivateProfileInt(pszSectionName, TEXT("TerrestrialIndex2"), -1, pszIniFileName);
			m_fTerraIndex2Specified = m_TerrestrialIndex2 >= 0;
		}
		m_BSIndex = ::GetPrivateProfileInt(pszSectionName, TEXT("BSIndex"), -1, pszIniFileName);
		m_fBSIndexSpecified = m_BSIndex >= 0;
		m_CSIndex = GetPrivateProfileInt(pszSectionName, TEXT("CSIndex"), -1, pszIniFileName);
		m_fCSIndexSpecified = m_CSIndex >= 0;

		// BS/CS̎gݒ̓ǂݍ
		if (!LoadFrequencySettings(pszIniFileName, TEXT("BSFrequency"), &m_BSChannelList)) {
			m_BSChannelList.resize(ArrayLength(DefaultBSChannelList));
			for (size_t i = 0; i < ArrayLength(DefaultBSChannelList) ; i++)
				m_BSChannelList[i] = DefaultBSChannelList[i];
		}
		GetFrequencyRange(m_BSChannelList, &m_BSFrequencyRange);
		if (!LoadFrequencySettings(pszIniFileName, TEXT("CSFrequency"), &m_CSChannelList)) {
			m_CSChannelList.resize(ArrayLength(DefaultCSChannelList));
			for (size_t i = 0; i < ArrayLength(DefaultCSChannelList) ; i++)
				m_CSChannelList[i] = DefaultCSChannelList[i];
		}
		GetFrequencyRange(m_CSChannelList, &m_CSFrequencyRange);
	}

	void SetProperty(RockProperty *pProp) {
		int i = 0;

		// `[jOԂ̃CfbNX蓖Ă(̒iKł͂܂)
		if (pProp->UseTS()) {
			if (!m_fTerraIndexSpecified)
				m_TerrestrialIndex = i++;
			else
				i = m_TerrestrialIndex + 1;
		} else {
			m_TerrestrialIndex = -1;
		}
		if (pProp->UseBS()) {
			if (!m_fBSIndexSpecified)
				m_BSIndex = i++;
			else
				i = m_BSIndex + 1;
		} else {
			m_BSIndex = -1;
		}
		if (pProp->UseCS()) {
			if (!m_fCSIndexSpecified)
				m_CSIndex = i++;
		} else {
			m_CSIndex = -1;
		}
	}

	// TvRock̃`lύXv̏
	bool SetChannel(const DWORD dwChannel, const DWORD dwService) {
		if (!m_fInitialized)
			GetSpaceIndex();

		TVTest::ChannelInfo ChannelInfo;

		if (dwChannel <= TERRESTRIAL_CHANNEL_LAST) {
			// n
			int SpaceIndex[2];
			int NumSpaces = 0;

			if (m_TerrestrialIndex >= 0) {
				SpaceIndex[NumSpaces++] = m_TerrestrialIndex;
				if (m_TerrestrialIndex2 >= 0 && m_TerrestrialIndex2 != m_TerrestrialIndex)
					SpaceIndex[NumSpaces++] = m_TerrestrialIndex2;
			}

			// `l̃CfbNX/T[rXIDɈv`lT
			for (int i = 0; i < NumSpaces; i++) {
				const int Space = SpaceIndex[i];
				for (int j = 0; m_pApp->GetChannelInfo(Space, j ,&ChannelInfo); j++) {
					if (ChannelInfo.Channel == dwChannel - TERRESTRIAL_CHANNEL_FIRST
							&& (dwService == 0 || ChannelInfo.ServiceID == dwService))
						return m_pApp->SetChannel(Space, j);
				}
			}
			// T[rXID̈v`lT
			if (dwService != 0) {
				for (int i = 0; i < NumSpaces; i++) {
					const int Space = SpaceIndex[i];
					const int Channel = FindChannelByServiceID(Space, (WORD)dwService);
					if (Channel >= 0)
						return m_pApp->SetChannel(Space, Channel);
				}
			}
			// `l̃CfbNXv`lT
			for (int i = 0; i < NumSpaces; i++) {
				const int Space = SpaceIndex[i];
				for (int j = 0; m_pApp->GetChannelInfo(Space, j, &ChannelInfo); j++) {
					if (ChannelInfo.Channel == dwChannel - TERRESTRIAL_CHANNEL_FIRST)
						return SetChannel(Space, j, (WORD)dwService);
				}
			}
		} else if (m_BSIndex >= 0 || m_CSIndex >= 0) {
			// BS/CS
			const WORD Frequency = (WORD)(dwChannel >> 16), TSID = (WORD)(dwChannel & 0xFFFF);

			if (TSID != 0) {
				int Space, Channel;

				if (m_CSIndex < 0 || IsBsTSID(TSID)) {
					Space = m_BSIndex;
				} else {
					Space = m_CSIndex;
				}
				if (dwService != 0) {
					// TSIDƃT[rXIDv`lT
					Channel = FindChannelByTSIDAndServiceID(Space, TSID, (WORD)dwService);
					if (Channel >= 0)
						return SetChannel(Space, Channel, (WORD)dwService);
					m_pApp->AddLog(L"w肳ꂽTSIDƃT[rXIDɈv`l܂B");
				}
				// TSIDŒTĂ݂
				Channel = FindChannelByTSIDAndServiceID(Space, TSID, 0);
				if (Channel >= 0)
					return SetChannel(Space, Channel, (WORD)dwService);
			}

			if (dwService != 0) {
				enum {
					SPACE_UNKNOWN,
					SPACE_BS,
					SPACE_CS
				} SpaceType = SPACE_UNKNOWN;

				// gƃT[rXIDv`lT
				if (m_BSIndex >= 0) {
					for (size_t i = 0; i < m_BSChannelList.size(); i++) {
						if (m_BSChannelList[i].Frequency == Frequency) {
							const int Channel = FindChannelByTSIDAndServiceID(
								m_BSIndex, m_BSChannelList[i].TSID, (WORD)dwService);
							if (Channel >= 0)
								return SetChannel(m_BSIndex, Channel, (WORD)dwService);
							SpaceType = SPACE_BS;
						}
					}
				}
				if (m_CSIndex >= 0) {
					for (size_t i = 0; i < m_CSChannelList.size(); i++) {
						if (m_CSChannelList[i].Frequency == Frequency) {
							const int Channel = FindChannelByTSIDAndServiceID(
								m_CSIndex, m_CSChannelList[i].TSID, (WORD)dwService);
							if (Channel >= 0)
								return SetChannel(m_CSIndex, Channel, (WORD)dwService);
							SpaceType = SPACE_CS;
						}
					}
				}
				m_pApp->AddLog(L"w肳ꂽgƃT[rXIDɈv`l܂B");
				if (SpaceType == SPACE_UNKNOWN) {
					if (m_BSIndex >= 0
							&& Frequency >= m_BSFrequencyRange.Min
							&& Frequency <= m_BSFrequencyRange.Max)
						SpaceType = SPACE_BS;
					else if (m_CSIndex >= 0
							&& Frequency >= m_CSFrequencyRange.Min
							&& Frequency <= m_CSFrequencyRange.Max)
						SpaceType = SPACE_CS;
				}
				// T[rXIDŒTĂ݂
				int Space = -1;
				if (SpaceType != SPACE_UNKNOWN) {
					if (SpaceType == SPACE_BS)
						Space = m_BSIndex;
					else
						Space = m_CSIndex;
					if (m_BSIndex == m_CSIndex) {
						for (int i = 0; m_pApp->GetChannelInfo(Space, i ,&ChannelInfo); i++) {
							if (ChannelInfo.ServiceID == dwService
									&& ((SpaceType == SPACE_BS
										&& (IsBsNetworkID(ChannelInfo.NetworkID)
											|| IsBsTSID(ChannelInfo.TransportStreamID)))
									|| (SpaceType == SPACE_CS
										&& (IsCsNetworkID(ChannelInfo.NetworkID)
											|| IsCsTSID(ChannelInfo.TransportStreamID)))))
								return m_pApp->SetChannel(Space, i);
						}
					} else {
						const int Channel = FindChannelByServiceID(Space, (WORD)dwService);
						if (Channel >= 0)
							return SetChannel(Space, Channel, (WORD)dwService);
					}
				}
				if (m_BSIndex >= 0 && m_BSIndex != Space) {
					const int Channel = FindChannelByServiceID(m_BSIndex, (WORD)dwService);
					if (Channel >= 0)
						return SetChannel(m_BSIndex, Channel, (WORD)dwService);
				}
				if (m_CSIndex >= 0 && m_CSIndex != Space) {
					const int Channel = FindChannelByServiceID(m_CSIndex, (WORD)dwService);
					if (Channel >= 0)
						return SetChannel(m_CSIndex, Channel, (WORD)dwService);
				}
			}
		}

		m_pApp->AddLog(L"Y`l܂B");
		return false;
	}

	// ݂̃`lTvRocǩ`Ŏ擾
	DWORD GetChannel() {
		if (!m_fInitialized)
			GetSpaceIndex();

		TVTest::ChannelInfo ChannelInfo;
		if (!m_pApp->GetCurrentChannelInfo(&ChannelInfo))
			return 0;
		if (ChannelInfo.Space == m_TerrestrialIndex
				|| ChannelInfo.Space == m_TerrestrialIndex2) {
			return ChannelInfo.Channel + TERRESTRIAL_CHANNEL_FIRST;
		}
		for (size_t i = 0; i < m_BSChannelList.size(); i++) {
			if (m_BSChannelList[i].TSID == ChannelInfo.TransportStreamID)
				return ((DWORD)m_BSChannelList[i].Frequency << 16) |
						(DWORD)m_BSChannelList[i].TSID;
		}
		for (size_t i = 0; i < m_CSChannelList.size(); i++) {
			if (m_CSChannelList[i].TSID == ChannelInfo.TransportStreamID)
				return ((DWORD)m_CSChannelList[i].Frequency << 16) |
						(DWORD)m_CSChannelList[i].TSID;
		}
		return 0;
	}
};


// TvRock̗v󂯎NX
class CTvRockRequest : public RockRequest
{
	TVTest::CTVTestApp *m_pApp;
	CChannelSearch *m_pChannel;

public:
	CTvRockRequest(TVTest::CTVTestApp *pApp, CChannelSearch *pChannel)
		: m_pApp(pApp)
		, m_pChannel(pChannel) {
	}
	// AvI̗v
	void PowerOff() {
		m_pApp->AddLog(L"TvRockIv󂯂܂B");
		m_pApp->Close(TVTest::CLOSE_EXIT);
	}
	// `lύX̗v
	bool ChannelChange(const DWORD dwChannel, const DWORD dwService) {
		WCHAR szLog[128];
		::wsprintfW(szLog,L"TvRock`lύXv󂯂܂B(Ch %lu / Sv %lu)",dwChannel,dwService);
		m_pApp->AddLog(szLog);

		return m_pChannel->SetChannel(dwChannel, dwService);
	}
	// ^Jn̗v
	bool RecordStart(LPWSTR lpFileName) {
		WCHAR szLog[MAX_PATH+64];
		::wsprintfW(szLog,L"TvRock^Jnv󂯂܂B(%s)",lpFileName);
		m_pApp->AddLog(szLog);

		TVTest::RecordInfo RecordInfo;
		RecordInfo.Mask=TVTest::RECORD_MASK_FILENAME;
		RecordInfo.Flags=0;
		RecordInfo.pszFileName = lpFileName;
		RecordInfo.StartTimeSpec=TVTest::RECORD_START_NOTSPECIFIED;
		RecordInfo.StopTimeSpec=TVTest::RECORD_STOP_NOTSPECIFIED;
		return m_pApp->StartRecord(&RecordInfo);
	}
	// NCbN^Jn̗v (Rocko[̒ژ^̗v)
	bool QuickRecord(LPWSTR lpFileName) {
		WCHAR szLog[MAX_PATH+256];
		::wsprintfW(szLog,L"TvRockNCbN^Jnv󂯂܂B(%s)",lpFileName);
		m_pApp->AddLog(szLog);

		return RecordStart(lpFileName);
	}
	// ^~̗v
	bool RecordStop() {
		m_pApp->AddLog(L"TvRock^~v󂯂܂B");
		return m_pApp->StopRecord();
	}
	// Î~ۑ̗v
	void ScreenCapture() {
		//m_pApp->AddLog(L"TvRockÎ~ۑv󂯂܂B");
		m_pApp->SaveImage();
	}
	// IvV{^̗v
	void OnOption() {
		//m_pApp->AddLog(L"TvRockIvV{^̗v󂯂܂B");
		m_pApp->DoCommand(L"Options");
	}
	// rfIEBhEnh̗v (Rocko[E^bvEEBhETCYύX)
	HWND GetVideoHandle() {
		return m_pApp->GetAppWindow();
	}
	// ^[Qbg̎擾
	void CollectSetting() {
	}
	// bZ[W
	LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
		return 0;
	}
};


// NeBJZNV
class CCriticalLock
{
public:
	CCriticalLock();
	virtual ~CCriticalLock();
	void Lock(void);
	void Unlock(void);
	bool TryLock(DWORD TimeOut=0);
private:
	CRITICAL_SECTION m_CriticalSection;
};

CCriticalLock::CCriticalLock()
{
	::InitializeCriticalSection(&m_CriticalSection);
}

CCriticalLock::~CCriticalLock()
{
	::DeleteCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Lock(void)
{
	::EnterCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Unlock(void)
{
	::LeaveCriticalSection(&m_CriticalSection);
}

bool CCriticalLock::TryLock(DWORD TimeOut)
{
	bool bLocked=false;
	if (TimeOut==0) {
		if (::TryEnterCriticalSection(&m_CriticalSection))
			bLocked=true;
	} else {
		for (DWORD i=TimeOut;i>0;i--) {
			if (::TryEnterCriticalSection(&m_CriticalSection)) {
				bLocked=true;
				break;
			}
			Sleep(1);
		}
	}
	return bLocked;
}


// CTvRockDTVTarget (TVBridge蔲)
class CTvRockDTVTarget : public TVTest::CTVTestPlugin
{
	enum {
		DEFAULT_BUFFER_LENGTH      = 20000UL,
		MIN_BUFFER_LENGTH          = 10000UL,
		MAX_BUFFER_LENGTH          = 100000UL,
		DEFAULT_SEND_BUFFER_LENGTH = 256UL
	};
	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK StreamCallback(BYTE *pData,void *pClientData);
	HINSTANCE m_hPlug;
	TvRockDTV *m_pTvRock;
	CTvRockRequest *m_pRequest;
	CChannelSearch *m_pChannel;
	int m_DeviceID;
	WCHAR m_szDriverName[MAX_PATH];

	CCriticalLock m_StreamLock;
	HANDLE m_hProcessTSEvent;
	SIZE_T m_StreamBufferLength;
	BYTE *m_pStreamBuffer;
	SIZE_T m_StreamSendBufferLength;
	HANDLE m_hStreamThread;
	volatile bool m_fStreamEnd;
	DWORD m_DropCount;
	SIZE_T m_StreamBufferUsed;
	SIZE_T m_StreamBufferPos;

	bool GetStream(BYTE *pBuffer,SIZE_T *pBufferLength);
	void PurgeStream();
	static DWORD WINAPI StreamThread(LPVOID lpParameter);
	bool InitializeTvRockDTV(LPCWSTR pszCommandLine);
	static int GetDeviceID(LPCWSTR pszCommandLine,LPWSTR pszDriverName);

public:
	CTvRockDTVTarget()
		: m_hPlug(NULL)
		, m_pTvRock(NULL)
		, m_pRequest(NULL)
		, m_pChannel(NULL)
		, m_DeviceID(-1)
		, m_hProcessTSEvent(NULL)
		, m_StreamBufferLength(DEFAULT_BUFFER_LENGTH)
		, m_pStreamBuffer(NULL)
		, m_StreamSendBufferLength(DEFAULT_SEND_BUFFER_LENGTH)
		, m_hStreamThread(NULL)
		, m_fStreamEnd(false)
		, m_DropCount(0)
		, m_StreamBufferUsed(0)
		, m_StreamBufferPos(0)
	{
		m_szDriverName[0]=L'\0';
	}

	// vOC̏
	bool GetPluginInfo(TVTest::PluginInfo *pInfo)
	{
		pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
		pInfo->Flags          = 0;
		pInfo->pszPluginName  = L"TvRock DTV Target";
		pInfo->pszCopyright   = L"Public Domain";
		pInfo->pszDescription = L"TvRock DTV Target";
		return true;
	}

	// 
	bool Initialize()
	{
		InitializeTvRockDTV(::GetCommandLineW());

		m_pApp->SetEventCallback(EventCallback, this);

		return true;
	}

	// I
	bool Finalize()
	{
		m_pApp->SetStreamCallback(TVTest::STREAM_CALLBACK_REMOVE,StreamCallback);
		if (m_hStreamThread) {
			m_fStreamEnd=true;
			if (::WaitForSingleObject(m_hStreamThread,3000)==WAIT_TIMEOUT)
				::TerminateThread(m_hStreamThread,1);
			::CloseHandle(m_hStreamThread);
			m_hStreamThread=NULL;
		}
		if (m_hProcessTSEvent) {
			::CloseHandle(m_hProcessTSEvent);
			m_hProcessTSEvent=NULL;
		}
		if (m_pStreamBuffer) {
			delete [] m_pStreamBuffer;
			m_pStreamBuffer=NULL;
		}
		// TvRockDTVTargetp
		if (m_pTvRock) {
			m_pTvRock->Dispose();
			delete m_pTvRock;
			delete m_pRequest;
			m_pTvRock = NULL;
			m_pRequest = NULL;
			m_pApp->AddLog(L"TvRock DTV Target̏Is܂B");
		}
		if (m_hPlug) {
			::FreeLibrary(m_hPlug);
			m_hPlug=NULL;
		}
		if (m_pChannel) {
			delete m_pChannel;
			m_pChannel = NULL;
		}
		m_DeviceID=-1;
		m_szDriverName[0]=L'\0';
		return true;
	}

private:
	// TS
	void ProcessTS(BYTE *pData, const DWORD dwLeng)
	{
		static DWORD dwCount = 0;
		if (m_pTvRock) {
			m_pTvRock->ProcessTS(pData, dwLeng);
			dwCount += dwLeng;
			if (dwCount >= 0x100000) {
				RockStatus *pStat = m_pTvRock->GetStatus();
				if (pStat) {
					TVTest::StatusInfo StaInfo;
					m_pApp->GetStatus(&StaInfo);
					pStat->SetStatusSignalLevel(StaInfo.SignalLevel);
					pStat->SetStatusBitrate(StaInfo.BitRate * 8);
					pStat->SetStatusErrorPacket(StaInfo.ErrorPacketCount);
					pStat->SetStatusScramblingPacket(StaInfo.ScramblePacketCount);
				}
				dwCount -= 0x100000;
			}
		}
	}

	// Xg[̕ύX
	void StreamChange(const DWORD dwChannel, const DWORD dwService)
	{
		if (m_pTvRock)
			m_pTvRock->OnStreamChange(dwChannel, dwService);
	}

	// `l̎擾
	DWORD GetChannel()
	{
		return (m_pChannel ? m_pChannel->GetChannel() : 0);
	}

	// T[rX̎擾
	DWORD GetServiceID()
	{
		int Service = m_pApp->GetService();
		TVTest::ServiceInfo ServiceInfo;
		if (Service < 0 || !m_pApp->GetServiceInfo(Service, &ServiceInfo))
			return 0;
		return ServiceInfo.ServiceID;
	}
};

// Cxgʒm
LRESULT CALLBACK CTvRockDTVTarget::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	CTvRockDTVTarget *pThis=static_cast<CTvRockDTVTarget*>(pClientData);
	switch (Event) {
	case TVTest::EVENT_DRIVERCHANGE:
#if 0
		if (pThis->m_DeviceID>=0) {
			WCHAR szDriverName[MAX_PATH];

			szDriverName[0]='\0';
			pThis->m_pApp->GetDriverName(szDriverName,MAX_PATH);
			if (::lstrcmpi(::PathFindFileName(szDriverName),
						   ::PathFindFileName(pThis->m_szDriverName))!=0) {
				pThis->m_pApp->AddLog(L"hCoύXꂽ߁ATvRock DTV TargetI܂B");
				pThis->Finalize();
				return TRUE;
			}
		}
		// Fall through
#endif
	case TVTest::EVENT_CHANNELCHANGE:
		pThis->PurgeStream();
	case TVTest::EVENT_SERVICECHANGE:
	case TVTest::EVENT_SERVICEUPDATE:
		pThis->StreamChange(pThis->GetChannel(), pThis->GetServiceID());
		return TRUE;

	case TVTest::EVENT_EXECUTE:
		{
			LPCWSTR pszCommandLine=reinterpret_cast<LPCWSTR>(lParam1);
			WCHAR szDriverName[MAX_PATH];
			int DeviceID=GetDeviceID(pszCommandLine,szDriverName);
			if (DeviceID>=0
					&& (pThis->m_DeviceID<0 || pThis->m_DeviceID!=DeviceID)) {
				// VfoCXIDݒ
				pThis->Finalize();
				pThis->InitializeTvRockDTV(pszCommandLine);
			} else if (DeviceID<0 && pThis->m_DeviceID>=0
					&& szDriverName[0]!='\0') {
				pThis->Finalize();
			}
		}
		return TRUE;
	}
	return 0;
}

// Xg[̎擾
bool CTvRockDTVTarget::GetStream(BYTE *pBuffer,SIZE_T *pBufferLength)
{
	m_StreamLock.Lock();
	if (m_StreamBufferUsed == 0) {
		m_StreamLock.Unlock();
		return false;
	}
	SIZE_T Size = min(*pBufferLength,m_StreamBufferUsed);
	if (Size > m_StreamBufferLength-m_StreamBufferPos)
		Size = m_StreamBufferLength-m_StreamBufferPos;
	::CopyMemory(pBuffer,m_pStreamBuffer+m_StreamBufferPos*188,Size*188);
	*pBufferLength = Size;
	m_StreamBufferPos += Size;
	if (m_StreamBufferPos == m_StreamBufferLength)
		m_StreamBufferPos = 0;
	m_StreamBufferUsed -= Size;
	m_StreamLock.Unlock();
	return true;
}

// Xg[̔j
void CTvRockDTVTarget::PurgeStream()
{
	if (m_pTvRock!=NULL) {
		m_StreamLock.Lock();
		m_StreamBufferUsed = 0;
		m_StreamBufferPos = 0;
		m_StreamLock.Unlock();
		if (m_hProcessTSEvent != NULL) {
			::ResetEvent(m_hProcessTSEvent);
			::WaitForSingleObject(m_hProcessTSEvent, 5000);
		}
	}
}

// Xg[擾Xbh
DWORD WINAPI CTvRockDTVTarget::StreamThread(LPVOID lpParameter)
{
	CTvRockDTVTarget *pThis = static_cast<CTvRockDTVTarget*>(lpParameter);
	BYTE *pBuffer = new BYTE[pThis->m_StreamSendBufferLength*188];
	while (!pThis->m_fStreamEnd) {
		SIZE_T Length = pThis->m_StreamSendBufferLength;
		if (pThis->GetStream(pBuffer, &Length)) {
			pThis->ProcessTS(pBuffer, (DWORD)(Length*188));
			::SetEvent(pThis->m_hProcessTSEvent);
		} else {
			::SetEvent(pThis->m_hProcessTSEvent);
			::Sleep(10);
		}
	}
	delete [] pBuffer;
	return 0;
}

// Xg[
BOOL CALLBACK CTvRockDTVTarget::StreamCallback(BYTE *pData,void *pClientData)
{
	CTvRockDTVTarget *pThis = static_cast<CTvRockDTVTarget*>(pClientData);
	pThis->m_StreamLock.Lock();
	if (pThis->m_StreamBufferUsed == pThis->m_StreamBufferLength) {
		pThis->m_DropCount++;
		pThis->m_StreamLock.Unlock();
		return TRUE;
	}
	::CopyMemory(pThis->m_pStreamBuffer+(pThis->m_StreamBufferPos+pThis->m_StreamBufferUsed)%pThis->m_StreamBufferLength*188,pData,188);
	pThis->m_StreamBufferUsed++;
	pThis->m_StreamLock.Unlock();
	return TRUE;
}

// TvRockDTV̏
bool CTvRockDTVTarget::InitializeTvRockDTV(LPCWSTR pszCommandLine)
{
	// TvRock̓foCXʔԍKv
	m_DeviceID = GetDeviceID(pszCommandLine, m_szDriverName);
	if (m_DeviceID < 0) {
		if (m_DeviceID == -2)
			m_pApp->AddLog(L"DIDsłB");
		else
			m_pApp->AddLog(L"DIDw肳Ă܂B");
		return false;
	}

	WCHAR szLog[256];
	::wsprintfW(szLog, L"TvRock DTV Target܂B(DID %c)", m_DeviceID + 'A');
	m_pApp->AddLog(szLog);

	// TvRockDTVCu̓ǂݍ
	typedef TvRockDTV *(*CreateTvRockDTV)(HINSTANCE);
#ifdef WIN64
	m_hPlug = LoadDTVModule64();
#else
	m_hPlug = LoadDTVModule();
#endif
	if (m_hPlug==NULL) {
		m_pApp->AddLog(L"TvRockDTVCu܂B");
		Finalize();
		return false;
	}
	CreateTvRockDTV pFunc = (CreateTvRockDTV)::GetProcAddress(m_hPlug, "CreateTvRockDTV");
	if (pFunc == NULL) {
		m_pApp->AddLog(L"TvRockDTVCuv܂B");
		Finalize();
		return false;
	}

	// ̃vOC̓foCXł
	// xɕfoCX쐬Ă܂܂
	m_pTvRock = pFunc(m_hPlug);
	if (m_pTvRock == NULL) {
		m_pApp->AddLog(L"TvRockDTV쐬ł܂B");
		Finalize();
		return false;
	}

	// TvRock DTV Target (ɃfoCX݂ꍇG[)
	m_pChannel = new CChannelSearch(m_pApp);
	m_pRequest = new CTvRockRequest(m_pApp, m_pChannel);
	if (!m_pTvRock->Initialize(m_DeviceID, m_pRequest)) {
		m_pApp->AddLog(L"TvRockDTV̏G[łB");
		Finalize();
		return false;
	}

	// ݒ̓ǂݍ
	TCHAR szIniFileName[MAX_PATH], szSectionName[8];
	::GetModuleFileName(g_hinstDLL, szIniFileName, MAX_PATH);
	::PathRenameExtension(szIniFileName, TEXT(".ini"));
	m_StreamBufferLength = ::GetPrivateProfileInt(TEXT("Settings"), TEXT("BufferLength"), (INT)m_StreamBufferLength, szIniFileName);
	if (m_StreamBufferLength < MIN_BUFFER_LENGTH)
		m_StreamBufferLength = MIN_BUFFER_LENGTH;
	else if (m_StreamBufferLength > MAX_BUFFER_LENGTH)
		m_StreamBufferLength = MAX_BUFFER_LENGTH;
	wsprintf(szSectionName, TEXT("DID_%c"), m_DeviceID + 'A');
	m_pChannel->Init(szIniFileName, szSectionName);

	// ݒ̊mF
	RockProperty *pProp = m_pTvRock->GetProperty();
	if (pProp) {
		// ^t@Cgq̒
		WCHAR ext[MAX_PATH];
		memset(ext,0,sizeof(ext));
		pProp->GetFileExtension(ext, MAX_PATH);
		if (wcscmp(ext,FILE_EXTENSION)) {
			pProp->SetFileExtension(FILE_EXTENSION);
			pProp->Notify();
		}
		m_pChannel->SetProperty(pProp);

#if 0
		// pXTVTestɍ킹ꍇ
		WCHAR szRecFolder[MAX_PATH];
		if (m_pApp->GetSetting(L"RecordFolder", szRecFolder, MAX_PATH) > 0) {
			WCHAR szDefaultRecPath[MAX_PATH];
			pProp->GetRecordPath(szDefaultRecPath, MAX_PATH);
			if (wcscmp(szDefaultRecPath, szRecFolder)) {
				pProp->SetRecordPath(szRecFolder);
				pProp->Notify();
			}
		}
#endif
	}

	// obt@̏
	m_pStreamBuffer = new BYTE[m_StreamBufferLength * 188];
	m_StreamBufferUsed = 0;
	m_StreamBufferPos = 0;
	m_hProcessTSEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hStreamThread = ::CreateThread(NULL, 0, StreamThread, this, 0, NULL);
	m_pApp->SetStreamCallback(0, StreamCallback, this);

	return true;
}


// R}hCfoCXID擾
int CTvRockDTVTarget::GetDeviceID(LPCWSTR pszCommandLine,LPWSTR pszDriverName)
{
	pszDriverName[0]='\0';
	if (pszCommandLine == NULL || pszCommandLine[0] == '\0')
		return -1;

	int argc;
	LPWSTR *argv = ::CommandLineToArgvW(pszCommandLine, &argc);

	if (argv == NULL)
		return -1;
	int DeviceID = -1;
	for (int i=0; i<(argc-1); i++) {
		if (::lstrcmpiW(argv[i], L"/DID") == 0) {
			if (argv[i+1][0] >= L'A' && argv[i+1][0] <= L'H') {
				DeviceID = (argv[i+1][0] - L'A');
			} else if (argv[i+1][0] >= L'a' && argv[i+1][0] <= L'h') {
				DeviceID = (argv[i+1][0] - L'a');
			} else {
				DeviceID = -2;
			}
		} else if (::lstrcmpiW(argv[i], L"/d") == 0) {
			if (::lstrlenW(argv[i+1]) < MAX_PATH)
				::lstrcpyW(pszDriverName,argv[i+1]);
		}
	}
	LocalFree(argv);
	if (DeviceID < 0)
		pszDriverName[0]='\0';
	return DeviceID;
}


// vOCEGg
TVTest::CTVTestPlugin *CreatePluginClass()
{
	return new CTvRockDTVTarget;
}
